# Axii Changelog

This document accumulates all changes to Axii with the respective version

[[_TOC_]]

---

<!-- changelog-placeholder -->


## Releases 25.03


### Release [25.03.1.0](https://git.h2t.iar.kit.edu/sw/armarx/meta/axii/-/releases/25.03.1.0)

**Update procedure**:

- `axii self update`
- (with workspace activated) `axii workspace verify`

**Features:**

- Ubuntu 24 support (@pohl, @uzivy_duran, @reister !783)
- Allow creating subconfigs from command line (@dreher, !847)

**Modules:**

- **New** `armarx_integration/robots/franka_emika_fr3`: New modules with dependencies for Franka Emika FR3 robots (@dreher, !855)
- `armarx/skills/manipulation`: Add missing dependency of armarx/skills/symbolic_planning (@dreher, !854)
- `armarx/skills/localization_and_mapping`: Add missing dependency (@dreher, !853)
- `deps/spinnaker`: Development spinnaker deps update (@schlosser, !852)
- `armarx/skills/speech`: Add missing dependency (@dreher, !851)
- `armarx/core/armarest`: Remove ARMAREST build step (@ughlu_gleissner, !850)
- `armarx/skills/mobile_manipulation`: Add missing dependency (@reister, !848)
- `deps/azure-kinect/*`: Re-export LD_LIBRARY_PATH to prevent common issues until shims are distributed (@reister, !845)
- `deps/azure-kinect/*`: Minor Noble-specific adjustments (@dreher, !856)
- `deps/gazebosim/*`: Disable doc build to speed up build process (@reister, !844)
- **New** `deps/spinnaker`, `armarx_integration/devices/cameras/spinnaker_armarx`: Add modules for spinnaker integration (@schlosser, !843)
- `armarx/python3-armarx`, `deps/mycroft-core`: Use default version of python (@birr, !842)

**Fixes:**

- Fix setting nested config variables (@uqrmq_weberruss, !840)


## Releases 25.01


### Release [25.01.1.0](https://git.h2t.iar.kit.edu/sw/armarx/meta/axii/-/releases/25.01.1.0)

**Update procedure**:

- `axii self update`
- (with workspace activated) `axii workspace verify`

**Features:**

- Allow setting the default workspaces directory (@dreher, !838)

**Modules:**

- `deps/vtk`: Fix issues with VTK and MPI primarily related to VisionX (@dreher, !839)
- **New** `tools/python/3.12`: Add Python 3.12 module (@dreher, !837)
- **New** `deps/orbbec_sdk_v2/*`: Various modules related to interfacing with Orbbec cameras (@dreher, !836)
- `deps/rbdl`: Fix CMake variable name for building addon urdfreader of RBDL library (@meixner, !833)
- `deps/rbdl`: Add missing Eigen dependency (@reister, !829)
- `armarx/skills/manipulation`: Add missing dependency (@reister, !828)
- `h2t/code_style`: Add rbdl to clang-format include order (@reister, !826)
- **New** `armarx_integration/robots/armar6/dialog`, `armarx_integration/dialog/google_tts`: Add modules for dialog repositories for ARMAR-6, Google TTS (@birr, !825)

**Fixes:**

- Generally overhaul bootstrap procedure to ensure latest pip, setuptools, wheel (@dreher, !831, !832, !834)

_Other:_

- Add description of how to handle transitive dependencies in required_modules (@birr, !824)
- Prepare CI for Ubuntu 24.04 "Noble" (@uzivy_duran, @dreher, !808, !835)


## Releases 24.12


### Release [24.12.2.0](https://git.h2t.iar.kit.edu/sw/armarx/meta/axii/-/releases/24.12.2.0)

**Update procedure**:

- `axii self update`
- (with workspace activated) `axii workspace verify`

**Modules:**

- `research/robot-utils`, `research/robot-vision`: Fix `default_checkout_ref` to `main` (@reister, !823)
- `deps/opencv-4/main`: Enable SFM (@reister, !822)
- `armarx_integration/object_localization/ivt_armarx`, `armarx_integration/SimTrackArmarX`: Remove unneeded dependencies (@reister, !821)
- **New** `deps/pqp`, `deps/pugixml`: Add new modules (@reister, !816)
- `simox`: Add pugixml as dependency (@reister, !820)
- `simox`: Remove 3rd party libraries shipped with Simox (rbdl and nlohmann_json) (@meixner, !819)
- `axii`: Use Axii stable release by default (@dreher, !818)
- `simox`: Add new feature spacenavigator as input device (@reister, !817)
- **New** `deps/magic_enum`: Add module (@reister, !815)
- `tools/clang+llvm/17.0`: Shim for git-clang-format-17 (@reister, !814)
- `h2t/code_style`: Update clang-format files (@reister, !813)
- `h2t/code_style`: Improve clang tidy and clangd configs (@reister, !809)
- `armarx/RobotAPI`: Add PCL as dependency (@reister, !782)

**Fixes:**

- More graceful handling of not-found modules (@dreher, !805)

_Other:_

- Add default merge request template (@dreher, !811)
- Update file contributing file (@dreher, !810)


### Release [24.12.1.0](https://git.h2t.iar.kit.edu/sw/armarx/meta/axii/-/releases/24.12.1.0)

**Update procedure**:

- `axii self update`
- (with workspace activated) `axii workspace verify`

**Features:**

- Key update for workspace Git status view (@dreher, !803)
- Allow workspace-specific Axii installs (@dreher, !799)
- Allow setting the default behavior of the update step during an upgrade (@dreher, !794)

**Modules:**

- `armarx/VisionX`: Don't treat new warnings as errors (@dreher, !801)
- `h2t/code_style`: Add clang tidy and clang format to h2t/research_projects (@usnlf_albrecht, !800)
- `armarx/skills/human_robot_interaction`: Fix misspelled module (@hyseni, !797)
- `armarx_integration/robots/armar6/skills`, `armarx/skills/human_robot_interaction`: Add missing dependencies (@nefzer, !796)
- **New** `h2t/systempinger`: Add new system pinger module (@dreher, !793)
- **New** `makeable`: Add MAkEable modules (@reister, !792)
- `tools/python/*`: Add needed Python dependencies for from-source-build (@dreher, !790)
- `armarx/skills/manipulation`, `armarx/skills/mobile_manipulation`: MAkEable release (@reister, !788)
- `armarx/skills/vision`: adding feature object learning (@meixner, !785)
- `robot_control/controllers`: Re-order repos (@dreher, !784)
- **New** `armarx_integration/dialog/whisper_asr`: Add module (@birr, !781)
- `armarx/skills/manipulation`: Add apt libyaml-cpp-dev dependency (@krebs, !780)
- **New** `armarx_integration/calibration/extrinsic_camera_calibration`: Add module (@reister, !779)
- `armarx/skills/speech`: Add python-modules `tts_base` and `asr_base` and update armarx_integration/dialog accordingly (@eb5303_baermann, !752)

**Fixes:**

- Derive Axii workspace name from Axii config (@dreher, !802)
- Switch to python3.10-venv as apt dependency (@daab, !795)
- Search both stderr and stdout for indications that the build process went OOM (@dreher, !778)
- Removing appended paths for workspace deactivation/switching in bash (@meixner, !777)


## Releases 24.07


### Release [24.07.2.0](https://git.h2t.iar.kit.edu/sw/armarx/meta/axii/-/releases/24.07.2.0)

**Update procedure**:

- `axii self update`
- (with workspace activated) `axii workspace verify`

**Modules:**

- `armarx/skills/control`: Made simox-control optional when adding armarx module (@meixner, !771)

_Other:_

- Update contributing (@dreher, !775)


### Release [24.07.1.1](https://git.h2t.iar.kit.edu/sw/armarx/meta/axii/-/releases/24.07.1.1)

Hotfix for environment variables of Python 3.10.

**Update procedure**:

- `axii self update`
- (with workspace activated) `axii workspace verify`


### Release [24.07.1.0](https://git.h2t.iar.kit.edu/sw/armarx/meta/axii/-/releases/24.07.1.0)

**Update procedure**:

- `axii self update`
- (with workspace activated) `axii workspace verify`

**Features:**

- Display current Git commit hash in `axii workspace git status` report (@uzivy_duran, !769)
- Add build and venv options to clean command (@uzivy_duran, !760)

**Modules:**

- `deps/opencv-3`: Switched OpenCV3 version from 3.4.16/3.4.17 to most recent 3.4.20 (@dreher, !768)
- **New** `deps/cuda/cuda-11.8-cudnn-8.9`: Added module for CUDA 11.8 with cuDNN 8.9 (@meixner, !766)
- `deps/godot`: Change Godot module URLs from tuxfamily.org to GitHub (@rietsch, !764)
- `tools/lazygit/0.40.2`: fix download link (@uzivy_duran, !762)
- **New** `deps/ros2`: Add ROS2 Humble (@hyseni, !728)
- **New** `armarx_integration/calibration/dynamic_parameter`: Added DynamicParameter module for torque calibration (@meixner, !586)

**Fixes:**

- Fixed environment variable resolution in cmake/prepare (@meixner, !765)


## Releases 24.04


### Release [24.04.1.0](https://git.h2t.iar.kit.edu/sw/armarx/meta/axii/-/releases/24.04.1.0)

**Update procedure**:

- `axii self update`
- (with workspace activated) `axii workspace verify`

**Features:**

- Dedicated update of Axii installed executables on upgrade/install (@uzivy_duran, !735)

**Modules:**

- `tools/python/3.10`: Fix several follow-up issues resulting from building Python 3.10 with `--enable-shared` (@uzivy_duran, @dreher, !756, !759, !761)
- `armarx/skills/control`: Add SimoxControl dependency (@uyrdb_dormanns, !754)

**Fixes:**

- Properly collect execs even if install is a substeps-list (@dreher, !755)
- Remove activated features from workspace (@uzivy_duran, !738)
- Improve workspace `clean` command to also clean up Python venvs and allow resetting the workspace OS fingerprint (@uzivy_duran, !737)

_Other:_

- Fix typo in README (@usnlf_albrecht, !750)


## Releases 24.01


### Release [24.01.2.2](https://git.h2t.iar.kit.edu/sw/armarx/meta/axii/-/releases/24.01.2.2)

**Note**:

- This is a patch release

Hotfix for issues with OS fingerprints in legacy workspaces.


### Release [24.01.2.1](https://git.h2t.iar.kit.edu/sw/armarx/meta/axii/-/releases/24.01.2.1)

**Note**:

- This is a patch release

Hotfix for issues with two modules.


### Release [24.01.2.0](https://git.h2t.iar.kit.edu/sw/armarx/meta/axii/-/releases/24.01.2.0)

**Update procedure**:

- `axii self update`
- (with workspace activated) `axii workspace verify`

**Modules:**

- **New** `tools/pycharm/professional/2023.3.3`: Add Module (@uzivy_duran, !743)
- `armarx/skills/audio`: Add missing requirements (@uzivy_duran, !739)
- **New** `tools/lazygit`: Add module (@uzivy_duran, !734)
- `tools/git/2.35`: Fix Git 2.35 build script permissions (@ughlu_gleissner, !733)
- `armarx/core/fluxio/frontend`: Simplified the installation steps and executables of Fluxio by creating a single script (@uzivy_duran, !731)
- `armarx/core/armarest`: Use setup scripts in repository instead make for setup (@uzivy_duran, !730)
- **New** `tools/nvim/0.9.5`, `tools/obsidian/1.5.3`: Add neovim and obsidian module (@uzivy_duran, !729)
- `h2t/playground/bundle_sdf`: Requirements and necessary Installation flags (@pohl, !720)
- `armarx/skills/mobile_manipulation`: Add missing dependency (@pohl, !705)

**Fixes:**

- Choose correct virtual environment in self report subcommand (@uzivy_duran, !740)
- Fix Ubuntu version codename check (@uzivy_duran, !736)

_Other:_

- Minor code improvements and refactorings (@daab, !744)


### Release [24.01.1.0](https://git.h2t.iar.kit.edu/sw/armarx/meta/axii/-/releases/24.01.1.0)

**Update procedure**:

- `axii self update`
- (with workspace activated) `axii workspace verify`

**Features:**

- Multi-OS support (@dreher, !719)
- Ubuntu 24 support (@pohl, !715)

**Modules:**

- `robot_control`: Add missing dependencies (@dreher, !727)
- `armarx/core/armarest`: Change requirey Python version to 3.10, cleanup of deprecated modules (@uzivy_duran, !726)
- `deps/dlr_3d_object_tracking/icg`: Add missing dependency (@daab, !725)
- `armarx/python3-armarx`: Fix used Python version (@uzivy_duran, !724)
- **New** `tools/arduino/ide/2.2.1`: Add modules for Ardunio IDE v2 (@kartmann, !723)
- `deps/qwt/6.2.0`, `deps/soem/1.4`: Update Git ignore patterns (@dreher, !722)
- `robot_control/ethercat_integration/bus`: Rename project and module (@dreher, !721)
- **New** `tools/linux_rt_preemt/6.5`: Add Linux 6.5 with RT_PREEMPT patch as default RT kernel for Ubuntu 22 (@dreher, !718)
- **New** `deps/qwt/6.2.0`: Add module for Qwt 6.2.0 (@kartmann, !717)
- `h2t/research_projects/oml/oml_demo`: Adapts links to new repository (@uyrdb_dormanns, !716)
- `deps/manif`: Add missing Eigen3 dependency (@uzivy_duran, !713)
- **New** `tools/qtcreator/12.0`, `apt/gxx-12`, `tools/clang+llvm/17.0`: Roll out QtCreator 12.0 with GCC 12 and Clang 17 (@dreher, !708)
- **New** `tools/vs_code/flatpak`: Add flatpak version (@reister, !700)
- **New** `armarx_integration/ros_armarx/*`: Add modules for ros_armarx/documentation and ros_armarx/example, update existing core and generation (@ujrwq_arlt, !623)

_Other:_

- Update and extend the maintenance documentation on creating Axii releases (@daab, !714)


## Releases 23.12


### Release [23.12.1.0](https://git.h2t.iar.kit.edu/sw/armarx/meta/axii/-/releases/23.12.1.0)

**Update procedure**:

- `axii self update`
- (with workspace activated) `axii workspace verify`

**Modules:**

- **New** `deps/plog`, `deps/hpp_fcl`: Add plog, change release type in FCL (@reister, !711)
- `armarx_integration/ros_armarx/common`: Remove MemoryX from dependencies (@pohl, !709)
- `quant`: Add boost as library to quant core (@dreher, !707)
- `armarx/skills/vision`: Require VisionX (@kartmann, !706)
- `quant/core`: Require deps/eigen3 (@kartmann, !702)
- `tools/vs_code/*`: Reworked VS code module; adding new version (@reister, !690)
- `armarx/core/fluxio`, `armarx/core/armarest`: Move modules to new location (@uzivy_duran, !689)
- **New** `tools/nodejs/20.9`: Node.js 20.9 from source (@ughlu_gleissner, !686)

_Other:_

- Update docs on common workspace upgrade troubleshooting routines (@dreher, !710)
- Document running `git gui` in repos with uncommitted changes (@dreher, !704)
- Revise instructions for IDEs (@kartmann, !703)


## Releases 23.11


### Release [23.11.1.0](https://git.h2t.iar.kit.edu/sw/armarx/meta/axii/-/releases/23.11.1.0)

**Update procedure**:

- `axii self update`
- (with workspace activated) `axii workspace verify`

**Modules:**

- `deps/difflib`: Fix adding the target difflib::difflib multiple times (@kartmann, !697)
- `armarx_integration/dialog/mycroft_armarx`: Export mycroftarmarx_PYTHON_PACKAGE_DIR (@kartmann, !696)
- `armarx/python3-armarx`: Export python3_armarx_PYTHON_PACKAGE_DIR (@kartmann, !695)
- `simox`: Add difflib as requirement of simox (@kartmann, !694)
- **New** `deps/difflib`: Add module deps/difflib, a port of the Python difflib library (@kartmann, !693)
- `armarx_integration/dialog/mycroft_armarx`: Create own venv for mycroftarmarx which is needed by standalone python scripts (@kartmann, !692)
- `deps/mycroft-core`: Export MYCROFT_SKILLS_DIR and mycroft-* commands (@kartmann, !691)
- `h2t/user_specific_bashrc`: Add module for user-specific bashrc profiles (@kartmann, !688)
- **New** `armarx/skills/human_robot_interaction`: Add module for HRI skills (@peller, !687)


## Releases 23.10


### Release [23.10.2.0](https://git.h2t.iar.kit.edu/sw/armarx/meta/axii/-/releases/23.10.2.0)

**Update procedure**:

- `axii self update`
- (with workspace activated) `axii workspace verify`

**Features:**

- Auto-activate Axii workspaces if changing into any subdirectories of the workspace (@dreher, !679)

**Modules:**

- `armarx/skills/symbolic_planning`: Fix several issues with module's dependencies (@dreher, !684 !685)
- `armarx/skills/mobile_manipulation`: Add feature requiring armarx/skills/symbolic_planning (@kartmann, !683)
- **New** `armarx_integration/dialog/isl_tts`: Add ISL TTS module (@peller, !678)
- **New** `armarx/skills/symbolic_planning`: Add symbolic planning module (@peller, !677)
- `armarx_integration/robots/armar6/internal_pcs/vision`: Feature/moving cartographer armar6 changes (unpushed branch on ARMAR-6 vision PC user account) (@reister, !674)
- **New** `tools/linux_rt_preemt/5.4`: Linux RT preempt (@dreher, !673)
- **New** `deps/bazel`, `deps/drake`: Add modules (@usvjn_haag, !672)
- `armarx_integration/pronat_armarx`: Add module for ProNat and Integration into ArmarX (@uhxkb_naumann, !600)
- `tools/g++/6/local`: Add missing module (@dreher, !322)


### Release [23.10.1.0](https://git.h2t.iar.kit.edu/sw/armarx/meta/axii/-/releases/23.10.1.0)

**Update procedure**:

- `axii self update`
- (with workspace activated) `axii workspace verify`

**Features:**

- Utilities for silencing warnings (@dreher, !666)
- Retry build several times if detected that system ran OOM (@dreher, !664)

**Modules:**

- **New** `deps/qcustomplot`: Add module for QCustomPlot (@kartmann, !671)
- `h2t/research_projects/oml/verbal_manipulation`: Required new ArmarX packages (@kartmann, !670)
- `robot_control`: Add quant as required dependency of robot_control (@dreher, !668)
- `armarx/skills/manipulation`: Add missing required dependencies as from CMakeLists.txt of manipulation (@dreher, !667)
- `deps/pytorch3d`, `h2t/research_projects/oml/verbal_manipulation`: Add module for PyTorch3D, use in Verbal Manipulation (@kartmann, !663)
- `deps/cuda/*`: Fix CUDA/cuDNN default archives path hint (@dreher, !662)
- `robot_control`: Add Doxygen and CSS as dependencies for robot control (@dreher, !661)
- **New** `deps/awesome-doxygen-css`: Add module for Awesome Doxygen CSS (@dreher, !660)
- `armarx_integration/robots/armar6/internal_pcs/speech`: Update Mycroft module, add JuBot DB (@kartmann, !659)

**Fixes:**

- Distribute load on parallel updates by waiting a random amount of time (@dreher, !665)


## Releases 23.08


### Release [23.08.2.0](https://git.h2t.iar.kit.edu/sw/armarx/meta/axii/-/releases/23.08.2.0)

**Update procedure**:

- `axii self update`
- (with workspace activated) `axii workspace verify`

**Features:**

- Do not force stderr styling, but exclamation mark icon as prefix (@dreher, !658)

**Modules:**

- `tools/cmake`: Disable global package registry (@dreher, !657)
- **New** `tools/vs_code`: new versions of VS code (@reister, !656)
- `armarx/SpeechX`: Require armarx::speech (@uhxkb_naumann, !655)
- `armarx/skills/speech`: Add module for new ArmarX package armarx::speech (@uhxkb_naumann, !654)
- `deps/simtrack`, `deps/mycroft`: Move modules to new locations (@kartmann, !653)
- `h2t/research_projects/oml/verbal_manipulation`: Add and export python package spatial_affordance_region_relations (@kartmann, !652)
- `armarx_integration/robots/armarde/*`: Remove leftover modules (@pohl, !651)
- `armarx_integration/robots/armar6/skills`: Add localization and mapping (@peller, !649)
- `robot_control`: Add doctest and ETL as dependencies (@dreher, !648)
- `research/robot-vision`: Change default branch to master (@daab, !647)
- `armarx_integration/robots/armarde/*`: Transfer ARMAR-DE module to own DB (@pohl, !646)
- `robot_control`: Build Doxygen documentation (@dreher, !645)


### Release [23.08.1.0](https://git.h2t.iar.kit.edu/sw/armarx/meta/axii/-/releases/23.08.1.0)

**Update procedure**:

- `axii self update`
- (with workspace activated) `axii workspace verify`

**Modules:**

- `h2t/research_projects/oml/verbal_manipulation`: Export verbalmanipulation_PYTHON_PACKAGE_DIR (@kartmann, !644)
- `mice`: Updated mice repsitory links (@uyrdb_dormanns, !643)
- `deps/mujoco`: Fix wrong mujoco_DIR path (@usvjn_haag, !642)
- `armarx_integration/robots/armar6/skills`: Require Spoac explicitly (@kartmann, !639)
- `armarx/skills/localization_and_mapping`: Resolve "Fix dependencies of localization_and_mapping module" (@pohl, !638)
- `armarx/SpeechX`: Make Spoac and optional dependency of SpeechX (@pohl, !637)
- `armarx/skills/mobile_manipulation`: Update manipulation-pipeline feature of mobile_manipulation module (@pohl, !636)
- `armarx/VisionX`: Remove hard MemoryX dependency from VisionX module (@pohl, !635)
- `armarx/skills/view_selection`: Remove hard VisionX dependency from `armarx/skills/view_selection` (@pohl, !634)
- `armarx_integration/robots/armar6/skills`: Add view_selection as requirement of armar6_skills (@kartmann, !632)
- `armarx/RobotComponents`: Add feature 'mmm' to robot components (@kartmann, !631)
- `armarx_integration/robots/armar3`, `dbs/armarx_integration/robots/armar3`: Move module for Armar3 project to own module database (since it was moved to a group) (@kartmann, !630)
- `tools/qtcreator/*`: Update download URLs of archived QtCreator versions (@kartmann, !629)
- **New** `h2t/watermark`: Add modules for pqiv and H2T watermark display (@dreher, !627)
- `deps/mujoco`: Update mujoco module (@usvjn_haag, !624)
- `mmm/vision`: Adding module MMM Vision (@reister, !604)

**Fixes:**

- CI: Simulate install_axii.sh at the end of jammy (as is done in bionic) (@kartmann, !640)

_Other:_

- Extend documentation on tools workspace (@kartmann, !628)


## Releases 23.07


### Release [23.07.1.0](https://git.h2t.iar.kit.edu/sw/armarx/meta/axii/-/releases/23.07.1.0)

**Update procedure**:

- `axii self update`
- (with workspace activated) `axii workspace verify`

**Modules:**

- `robot_control/*`, `deps/soem`: Fix compile flags for Ubuntu 22.04 and build on Release mode by default (@dreher, !622)
- `deps/github_slug deps/sgment_anything`: Use github_slug in grounding_dino and segment_anything (@kartmann, !612)
- **New** `dbs/research_projects/reallabor`: Axii module database for Reallabor (@peller, !610)
- `armarx`: Include arviz_godot in ArmarX meta module (@kartmann, !606)
- `armarx_integration/robots/armar7/*`: Transfer ARMAR-7 modules to own Axii module DB (@kartmann, !603)
- `armarx/skills/observational_learning`: Remove unnecessary dependencies (@dreher, !602)
- `dbs/research_projects/jubot`: Move JuBot modules to own DB (@eb5303_baermann, !601)
- `armarx/SpeechX`: Use audio_memory in new_incremental_asr (@kartmann, !573)
- `tools/nomachine/latest`: Ann modules for Nomachine (@peller, !555)

**Fixes:**

- Add module definition file and Makefile itself to dependencies of Makefile updating Python Virtual Environments (@kartmann, !613)


## Releases 23.06


### Release [23.06.2.0](https://git.h2t.iar.kit.edu/sw/armarx/meta/axii/-/releases/23.06.2.0)

**Update procedure**:

- `axii self update`
- (with workspace activated) `axii workspace verify`

**Modules:**

- `armarx/skills/manipulation`: Add feature collision_checking requiring VisionX (@kartmann, !599)
- **New** `armarx_integration/human_body_tracking/mediapipe_pose_and_hands_armarx`: Add module for Mediapipe (pose and hand) ArmarX integration (@daab, !598)
- **New** `dbs/research_projects/haria`: Add module database for HARIA research project (@daab, !597)
- `deps/libssl1`: Update download URL of libssl1, add general URL (@kartmann, !596)
- `deps/soem/1.4`: Fix code style issues (@dreher, !595)
- `deps/soem/1.4`: Export SOEM_DIR as expected by our FindSOEM.cmake in diverse packages (@dreher, !594)

_Other:_

- Add stubs for all strategies (@dreher, !593)


### Release [23.06.1.0](https://git.h2t.iar.kit.edu/sw/armarx/meta/axii/-/releases/23.06.1.0)

**Update procedure**:

- `axii self update`
- (with workspace activated) `axii workspace verify`

**Features:**

- Feature: Add --this flag in axii edit module-definition (@kartmann, !583)
- Allow installing flatpak packages via system/packages or by directly depending on `flatpak/origin/com.application.Application` (@dreher, !579)
- feat: Shell-like environment variable expansions (@dreher, !571)

**Modules:**

- **New** `quant`: Add modules for quant (core C++ implementation and native Python bindings) (@dreher, !592)
- `tools/nodejs/16.19`: Export npx executable from NodeJS (@dreher, !590)
- `armarx/core/arviz_godot`: Remove non-existing branch for Ubuntu 22 (@dreher, !589)
- `deps/libssl1`: Update URL for new download (old not avialable) (@dreher, !588)
- `h2t/research_projects/oml`: Add pointing python package (@peller, !585)
- **New** `tools/qtcreator/10.0`, `tools/clang+llvm/16.0`: Add QtCreator 10 and Clang+LLVM 16 with fully pre-configured Axii Kits (@dreher, !582)
- `tools/ccache`: Fix Ccache recommended max size checks for newer Ccache versions (e.g., Ubuntu 22) (@dreher, !580)
- **New** `tools/pycharm/*/2023.1`: Add new PyCharm release (@dreher, !578)
- `deps/azure-kinect/body-tracking`: Bump minor version to fix CUDA-related issues (@meixner, !576)
- `armarx_integration/robots/armar6/internal_pcs/speech`: Add required modules from local workspace config, add armarx_audio (@kartmann, !574)
- **New** `deps/grounding_dino`, `deps/segment_anything`, `research/robot-utils`, `research/robot-vision`: New modules as dependencies for the euROBIN integration packages (@gao, !572)
- `h2t/research_projects/oml/oml_demo`: Create module for final OML demo by ISL (@kartmann, !569)

**Fixes:**

- Provide more information on diverse failures (@dreher, !587)
- Add fonts-noto-color-emoji as requirement in bootstrap (@dreher, !584)
- Filter "Updating files" stderr messages from Git (@dreher, !581)
- Fix and improve error handling for Git updates (@dreher, !577)


## Releases 23.04


### Release [23.04.2.0](https://git.h2t.iar.kit.edu/sw/armarx/meta/axii/-/releases/23.04.2.0)

**Update procedure**:

- `axii self update`
- (with workspace activated) `axii workspace verify`

**Modules:**

- **New** `armarx_integration/robots/franka_emika_panda`: ArmarX integration of the Franka Emika Panda, as well as libfranka and other related libraries (@dreher, !568)
- `armarx/skills/audio`: Create python env with ArmarX bindings (@kartmann, !565)
- `deps/rc_genicam_api`: Export Genicam_DIR (@pohl, !564)
- `armarx_integration/robots/armar6/skills`: Make ArmarXSimulation an optional dependency (@pohl, !563)
- `h2t/research_projects/oml/verbal_manipulation`: Add python env, author (@kartmann, !562)
- `armarx/skills/mobile_manipulation`: Add CGAL as optional dependency for the manipulation pipeline (@pohl, !560)
- **New** `deps/open3d`: Add module for Open3D (@pohl, !559)
- `tools/blenderbim`: (and dependencies) Add the BlenderBIM addon setup (@uomnk_mathes, !552)
- **New** `h2t/research_projects/jubot/extended_object_tracking`: Add module for extended object tracking (@reister, !529)
- **New** `tools/choregraphe/2.8.6`, `deps/zlib/1.2.9`, `h2t/research_projects/reallabor/*`: Add new modules (@peller, !522)
- `armarx/ArmarXSimulation`: Add range-v3 as dependency for simulation (@hegemann, !345)

_Other:_

- Documentation: Add KIT/SCC GitLab to examples for SSH settings (@kartmann, !570)


### Release [23.04.1.0](https://git.h2t.iar.kit.edu/sw/armarx/meta/axii/-/releases/23.04.1.0)

**Update procedure**:

- `axii self update`
- (with workspace activated) `axii workspace verify`

**Features:**

- Ask user in interactive mode if Ccache should be enabled (@jacob, !557)

**Modules:**

- `simox-control`: Fix `ERROR: Can not execute `setup.py` since setuptools is not available in the build environment.` (@pohl, !558)
- `armarx/skills/mobile_manipulation`: Fix inconsistent and wrong module dependencies (@pohl, !556)
- `armarx/Spoac`: Add missing dependency of Spoac for Elixir (@kartmann, !553)
- `h2t/research_projects/jubot/activity_recognition`: Use Python 3.10 for Jubot (@dreher, !551)
- `deps/libssl1`: Fix Debian package not being available anymore (@dreher, !550)
- `deps/cuda`: Set the XLA_FLAGS env var (@peller, !549)
- `h2t/research_projects/jubot/activity_recognition`: Revert to Python 3.6 (bound by Ice) (@dreher, !548)
- `h2t/research_projects/jubot/activity_recognition`: Use Python 3.11 as interpreter (@dreher, !547)


## Releases 23.03


### Release [23.03.3.0](https://git.h2t.iar.kit.edu/sw/armarx/meta/axii/-/releases/23.03.3.0)

**Update procedure**:

- `axii self update`
- (with workspace activated) `axii workspace verify`

**Features:**

- Enable users defining local module overrides unaffected by Git (@dreher, !542)
- Add Environment Context to building Python packages (@pohl, !541)

**Modules:**

- **New** `h2t/research_projects/jubot/activity_recognition`: Request azure_kinect feature from VisionX for JuBot activity recognition (@dreher, !546)
- **New** `armarest`: Add new module ARMAREST (@ueibz_kirmayer, !545)
- **New** `mice`: Add new module Mice (@uyrdb_dormanns, !543, !544)
- **New** `tools/python/3.9`: Add Python 3.9 (@pohl, !540)
- `h2t/research_projects/jubot/simulation`: Use correct python version in jubot_simulation (@kartmann, !539)
- `deps/soem/1.4`: Disable warning stringop-overflow being treated as error (@kartmann, !538)
- `deps/gazebosim/sdformat`: Add missing dependency ruby (@kartmann, !537)
- **New** `robot_control`: Add all modules for new `robot_control` repositories and projects (@dreher, !536)
- `armarx/skills/mobile_manipulation`: Add missing dependencies (@reister, !535)
- `armarx_integration/robots/armarde/skills`: Remove ArmarXSimulation from armarde/skills module (@pohl, !534)
- `simox-control`: Add Python package (@reister, !533)


### Release [23.03.2.0](https://git.h2t.iar.kit.edu/sw/armarx/meta/axii/-/releases/23.03.2.0)

**Update procedure**:

- `axii self update`
- (with workspace activated) `axii workspace verify`

**Modules:**

- **New** `h2t/research_projects/jubot/long_term_memory_data`: Add module for jubot_long_term_memory_data (@kartmann, !532)
- **New** `armarx/skills/audio`: Add module for armarx_audio (@kartmann, !531)
- **New** `tools/drawio/20.8`: Add module for draw.io 20.8.16 (@kartmann, !530)
- `h2t/code_style`: Add include order rules in clang-format files (@reister, !528)
- **New** `armarx/ArmarXSimulation`: Require gazeosim/sdformat (add modules for gazeosim/{gz-cmake, gz-util, gz-math, sdformat}) (@uomnk_mathes, !517)
- **New** `h2t/research_projects/jubot/simulation.json`: Use correct python version for the blender IFC-to-Robotics addon (add modules for Python 3.10.8, libffi) (@uomnk_mathes, !408)


### Release [23.03.1.0](https://git.h2t.iar.kit.edu/sw/armarx/meta/axii/-/releases/23.03.1.0)

**Update procedure**:

- `axii self update`
- (with workspace activated) `axii workspace verify`

**Modules:**

- `armarx/skills/movement_primitive_library`: Fix several dependency issues (@dreher, !527)
- **New** `armarx/skills/movement_primitive_library`: Add module for movement primitive library (@daab, !526)
- `h2t/data/tts-caches`: Fix creation of symlinks (@kartmann, !525)
- `armarx_integration/robots/armarde/skills`: Add missing dependency (@reister, !524)


## Releases 23.02


### Release [23.02.3.0](https://git.h2t.iar.kit.edu/sw/armarx/meta/axii/-/releases/23.02.3.0)

**Update procedure**:

- `axii self update`
- (with workspace activated) `axii workspace verify`

**Modules:**

- `armarx_integration/robots/armar7`: Integration ARMAR-7a (@reister, !519)
- `h2t/code_style`: Add "SeparateDefinitionBlocks: Always" to clang_format (@pohl, !514)
- `armarx/skills/manipulation`: Add ManipulationPipeline as feature for skills::manipulation (@pohl, !513)


### Release [23.02.2.0](https://git.h2t.iar.kit.edu/sw/armarx/meta/axii/-/releases/23.02.2.0)

**Update procedure**:

- `axii self update`
- (with workspace activated) `axii workspace verify`

**Modules:**

- `ivt/apt-dependencies`: Add missing dependency of IVT (@dreher, !516)
- `deps/coin/coin`: fix `LD_LIBRARY_PATH` of coin (@daab, !512)
- `armarx_integration/devices/laser_scanners/sick_scan_xd_armarx`: Fix email in authors section (@utetg_groeger, !511)
- `h2t/human_aware_navigation/teb_local_planner`: Add missing dependencies to `teb_local_planner` (@utetg_groeger, !510)
- `deps/azure-kinect/sensor-sdk`: Add missing dependency for `azure_kinect/sensor-sdk` on Ubuntu bionic (@utetg_groeger, !509)
- `armarx_integration/robots/armar6/skills`: Add navigation as skill for ARMAR-6 Skills (@utetg_groeger, !508)
- `h2t/research_projects/robdekon`: Remove deprecated dependencies (@pohl, !506)
- `armarx/meta/documentation`: Update project name of `armarx_documentation` (@kartmann, !505)
- **New** `h2t/research_projects/jubot/wiki`: Add module for JuBot Wiki and add it to main JuBot module (@kartmann, !504)
- `h2t/research_projects/robdekon/*`: Move PKD to `ROBDEKON_Sim` (@pohl, !503)
- `armarx/skills/mobile_manipulation`: Move perception for handover into a feature (@pohl, !501)
- `armarx/skills/navigation`: Make non-mandatory packages to features (@pohl, !500)
- `armarx/VisionX`: Make SemanticObjectRelations a feature in VisionX (@pohl, !499)
- `deps/sick_scan_base`: Remove obsolete sick driver (@utetg_groeger, !494)
- **New** `deps/sick_scan_xd`: Add `sick_scan_xd` module (@utetg_groeger, !493)

**Fixes:**

- Do not automatically quote all CMake definition values passed as arguments (@daab, !507)


### Release [23.02.1.0](https://git.h2t.iar.kit.edu/sw/armarx/meta/axii/-/releases/23.02.1.0)

**Update procedure**:

- `axii self update`
- (with workspace activated) `axii workspace verify`

**Modules:**

- **New** `armarx_integration/face_recognition/python_face_recognition_armarx`: Add module, remove python package `armarx_face_recognition` from VisionX (@kartmann, !497)
- `armarx_integration/robots/armarde/rt`: adding mplib feature to armarx/skills/control (@reister, !496)
- **New** `h2t/absolute_encoder_calibration`: Module for absolute encoder calibration on all robots (@dreher, !495)
- `deps/eigen3`: Use Eigen 3.3.9 from source only on Ubuntu 18, use apt/eigen on newer operating systems (@kartmann, !491)


## Releases 23.01


### Release [23.01.4.0](https://git.h2t.iar.kit.edu/sw/armarx/meta/axii/-/releases/23.01.4.0)

**Update procedure**:

- `axii self update`
- (with workspace activated) `axii workspace verify`

**Modules:**

- `h2t/research_projects/eurobin/*`: Move euROBIN modules to external DB (@kartmann, !490, !492)
- **New** `tools/nodejs/*`: Add modules for node and npm (@dreher, !489)
- `armarx/skills/control`: Remove constraint of building project with 4 jobs (@dreher, !488)
- **New** `armarx_integration/robots/armar6/*`: Add ARMAR-6 Models module (@dreher, !486)
- **New** `deps/embedded_template_library`: Add embedded_template_library module (@pohl, !485)

_Other:_

- OS-specific apt CI caches and pip CI caches (@dreher, !487)


### Release [23.01.3.0](https://git.h2t.iar.kit.edu/sw/armarx/meta/axii/-/releases/23.01.3.0)

**Update procedure**:

- `axii self update`
- (with workspace activated) `axii workspace verify`

**Modules:**

- **New** `deps/pybind`: Add pybind module (@pohl, !479)
- **New** `h2t/research_projects/jubot/*`: Add required modules (@kartmann, !477)
- `armarx/VisionX`: Add Python package `armarx_face_recognition` (@kartmann, !476)
- **New** `armarx/core/simulation`: Add new simulation and Bullet ArmarX modules (@hegemann, !349)

**Fixes:**

- Fix some aspects of `axii ci workspace create` (@kartmann, !482)
- Add all required modules of a feature to the dependency graph if indirectly satisfied (@pohl, !481)

_Other:_

- Add documentation for CI/CD engineers or downstream maintainers using Axii Docker images (@dreher, !480)
- Add hint about Git remote preferences (@kartmann, !478)
- Enable apt caching, clean up pylint job (@dreher, !484)
- Enable CI unit test reports (@dreher, !483)


### Release [23.01.2.0](https://git.h2t.iar.kit.edu/sw/armarx/meta/axii/-/releases/23.01.2.0)

**Update procedure**:

- `axii self update`
- (with workspace activated) `axii workspace verify`

**Features:**

- Resolve environment variables in update/download and prepare/extract (@dreher, !472)

**Modules:**

- `h2t/research_projects/jubot/*`: Add JuBot speech and demo (@kartmann, !474)
- `armarx/RobotAPI`: Remove obsolete dependencies of RobotAPI to MMM (@pohl, !471)
- `tools/clang+llvm/*`: Set extract path for tar files in order to ensure paths fit to configuration (@pohl, !465)

**Fixes:**

- Fix default values of built-in config variables not being interpreted if not set explicitly (@dreher, !475)
- Rework modules requiring installations with sudo by supplying installers (@dreher, !473)
- Expand environment variables in download update strategy and extract prepare strategy (@dreher, !468)
- Set cwd correctly to allow executing axii self report from anywhere (@dreher, !467)
- Ensure that extract_into directory exists for tar archives in extract strategy for update step (@dreher, !466)
- Properly parse Git output (consider stderr) and handle no-tracking branch case as warning (@dreher, !464)

_Other:_

- Update advanced user's documentation on VS Code (@reister, !469)
- General code cleanup (@dreher, !463)


### Release [23.01.1.0](https://git.h2t.iar.kit.edu/sw/armarx/meta/axii/-/releases/23.01.1.0)

**Update procedure**:

- `axii self update`
- Please note: From this release on, Axii will clone all Git repositories using HTTPS by default. If you want to use SSH for specific hosts (recommended for H2T GitLab, GitLab.com and GitHub), please follow the [advanced user's documentation on host-specific Git remote preferences](https://git.h2t.iar.kit.edu/sw/armarx/meta/axii/-/blob/stable/docs/advanced_users/README.md#git-remote-preferences).
- (with workspace activated) `axii workspace verify`

**Features:**

- Switch to HTTPS to global default Git clone method, supply configs to define host-based preferences (@dreher, !461)
- Basic functionality to allow for hierarchical configuration settings, implement `git_remote_preferences` config (@dreher, !455)
- Allow for multiple definition of the same step strategy and for multiple step phases (@dreher, !460)

**Modules:**

- `deps/coin/coin`: Disable building tests (@kartmann, !459)
- **New** `tools/vs_code/1.74.2`: Add Visual Studio Code module and config files (@reister, !439)
- `tools/clang+llvm/14.0`, `tools/clang+llvm/15.0`: Fix unavailable packages for Clang 14 and 15 (@reister, !437)

**Fixes:**

- Proper Rich parametrization for raw printing (@dreher, !453)
- Fix incorrect usage of `ignore_errors` in single build or install steps (@dreher, !452)
- Rework exception handling and robustness in `commands.execute` (@dreher, !449)

_Other:_

- Improve instructions for making the `axii` command globally available (@daab, !458)
- Add CI-specific workspace creation subcommand (@dreher, !428)
- Improve verification and installation of apt packages during bootstrap (@dreher, !462)
- Cleanup in `commands.execute` (@dreher, !454)


## Releases 22.12


### Release [22.12.5.2](https://git.h2t.iar.kit.edu/sw/armarx/meta/axii/-/releases/22.12.5.2)

Hotfix to avoid errors about missing `ignore_errors` flag for build or install steps.


### Release [22.12.5.1](https://git.h2t.iar.kit.edu/sw/armarx/meta/axii/-/releases/22.12.5.1)

Hotfix to avoid errors when cloning Git repositories into non-existing folders.


### Release [22.12.5.0](https://git.h2t.iar.kit.edu/sw/armarx/meta/axii/-/releases/22.12.5.0)

**Update procedure**:

- `axii self update`
- (with workspace activated) `axii workspace verify`

**Features:**

- Introduce workspace upgrade summary, rework step result reporting, workspace update (@dreher, !440)
- Allow getting module information in JSON format (@kartmann, !435)
- Resolve environment variables in archive update step URLs (@kartmann, !417)

**Modules:**

- **New** `armarx/core/realtime`:  Add package for ArmarX Realtime package (@pohl, !442)
- `deps/doctest`:  Deactive build of tests (@reister, !438)
- **New** `deps/nlohmann_json`, `deps/rbdl`, `deps/sciplot`:  Add several third party libraries (@reister, !436)
- **New** `system/architecture`:  Module to provide environment variables for system architecture (@pohl, !396)

**Fixes:**

- Dynamically expand variables to allow for changing environment after initialization (@dreher, !448)
- Handle errors from extracting tar in archive update strategy (@dreher, !447)
- Add `<experimental/*>` as C++ std header for clang-format (@dreher, !445)
- Fix Ccache module name in default generated workspace (@pohl, !444)
- Rename class for dummy data to avoid pytest-reserved "Test"-prefix causing warnings (@dreher, !443)
- Remove elements from nested lists in module definitions which are commented out (@kartmann, !441)
- When doing a self update, upgrade the virtual environment also when after not pulling the repository (@kartmann, !434)
- Ensure that user-supplied path is empty on workspace creation to avoid data loss (@dreher, !432)
- Fix subprocess stalling bug caused by Rich by bumping its version (@dreher, !430)
- Consider stderr a command produces as output in `decorated_execute` (@dreher, !429)

_Other:_

- Axii subcommand to generate self-report (@dreher, !433)
- Add debugging utilities to print exception tracebacks (@dreher, !431)


### Release [22.12.4.0](https://git.h2t.iar.kit.edu/sw/armarx/meta/axii/-/releases/22.12.4.0)

**Update procedure**:

- `axii self update`
- (with workspace activated) `axii workspace verify`

**Features:**

- Python Packages: Allow installing extra packages before `pip install -e .` (@kartmann, !406)

**Modules:**

- `deps/coin/soqt`:  Add missing dependency `apt/libqt5opengl5-dev` (@kartmann, !426)
- **New** `tools/pycharm/professional/2022.3`, `tools/pycharm/community/2022.3`:  Add PyCharm 2022.3 modules (@dreher, !421)
- `deps/vtk`:  Build VTK with Qt plugins (@pohl, !415)
- **New** `h2t/research_projects/jubot`:   Module for JuBot embedded computing and for all JuBot projects (@kartmann, !413)
- `deps/eigen3`:  Export `Eigen3_DIR` instead of `CMAKE_PREFIX_PATH` (@reister, !412)

**Fixes:**

- Hotfix for stalling issues in command execution by using standard Python print instead of Rich (@dreher, !427)
- Better handle single string commands in error messages (@kartmann, !422)
- Disable markup parsing, cropping and wrapping for executed command output (@dreher, !418)
- Silently fail fetching Axii while doing `axii w update` if interaction is required from SSH (@dreher, !414)
- Revamp looking up homepage, issues, merge requests of modules using `axii module open ...` (@dreher, !411)
- Still try to check out `default_checkout_commit` even if preferred cloning strategy failed in update step (@meixner, !403)

_Other:_

- Add note to not assign a reviewer when opening a MR (@dreher, !424)
- Add documentation for the Git strategy of the update step in module definitions (@dreher, !419)
- Update contribution guidelines (@dreher, !416)
- Add CODEOWNERS, clean up obsolete merge request templates (@dreher, !420)
- Improve robustness of maintainer's auto-release subcommand (@dreher, !410)
- Update labels and changelog generation for `axii self maintain release` (@dreher, !409)
- Clean up old executables, move all Python executables into app package (@dreher, !407)


### Release [22.12.3.0](https://git.h2t.iar.kit.edu/sw/armarx/meta/axii/-/releases/22.12.3.0)

**Update procedure**:

- `axii self update`
- (with workspace activated) `axii workspace verify`

**Features**:

- New Pipeline job to lint Markdown (@dreher, !400)
- Enable nice and ionice for Axii and all subprocesses via dedicated psutil API (@dreher, !399)
- Full in/out/err introspection of commands ran by Axii (@dreher, !398)
- Add switch_arch statement for configuring modules for different architectures (@pohl, !393, !394)
- Add jobs to build *-ci-dev docker images, do not use sudo when running apt-get install as root, properly export Axii to Docker image (@kartmann, !390)
- Add maintainer's subcommand to semi-automatically perform a release (@dreher, !387)
- New flag --accept-apt-install for System and --prefer-https for Update (@kartmann, !355)
- Add a hint about enabling Ccache in the quick start (@kartmann, !392)
- Update maintainer's documentation to reflect current release workflows (@dreher, !384)

**Modules**:

- **New** `tools/python/3.10`: Add Python 3.10 (@pohl, !405)
- `h2t/research_projects/oml/mycroft/mycroft-core`:  Export env variable for web cache config (@kartmann, !397)
- `apt/libpython`: Use libpython2-dev for Ubuntu 22.04 instead of libpython-dev (@jacob, !389)
- `armarx/meta/ArmarXDoc`: Declared deprecated in favor of armarx/meta/documentation (@kartmann, !385)
- `ivt`: Move IVT modules to new top-level module namespace "ivt", deprecate old names in "deps/ivt" (@reister, !369)
- `deps/opencv-4/contrib`: Fixed and enabled OpenCV4 contrib module (@reister, !311)

**Fixes**:

- Fix an issue in CI pipeline job for Axii Docker image testing (@kartmann, !402)
- Correctly ignore errors in steps if requested via --ignore-errors (@kartmann, !401)
- Evaluate potential environment variables when passing a concrete Python interpreter for creating a venv in prepare (@kartmann, !395)


### Release [22.12.2.0](https://git.h2t.iar.kit.edu/sw/armarx/meta/axii/-/releases/22.12.2.0)

**Update procedure**:

- `axii self update`
- (with workspace activated) `axii workspace verify`

**Features**:

- Build Docker images for for releases of Axii (@dreher, !366)
- Build Docker images for development versions of Axii (@dreher, !378, !383)
- Shell integration for `axii workspace purge` and `axii config`, configurable update job number (@dreher, !370)
- Code quality improvements (@dreher, !365)
- Module linting (@dreher, !373)
- Documentation updates (@dreher, @marquardt, @dezman, !381)

**Modules**:

- **New** `deps/hpp_fcl`: HPP-FCL, extended flexible collision library (@meixner, @reister, !368)
- **New** `deps/torch/cpu` and `deps/torch/cpu`: to run trained PyTorch neural networks in C++. Will be used in `SimoxControl`. (@reister , !367)
- **New** `h2t/haptic_exploration/*`: Haptic exploration projects migrated from Redmine, optional dependency of `Armar3` (@kartmann, !375)
- **New** `tools/python/3.11`: Add Python 3.11 as tool (@dreher, @meixner, !377)
- **New** `armarx_integration/robots/kit_exo_2`: KIT Exo II (@dreher, !379)
- `deps/coin/coin`: Properly export package (@kartmann, !372)
- `etherkitten` and `h2t/raw_socket`: Properly set up module definitions, revamp installation, make use of setcaps, fix dependencies (@dreher, @kartmann, @pohl, @hundhausen, !352)

**Fixes**:

- Fixed an issue with installing `apt` packages from `./bootstrap.sh` (@dreher, !380)


### Release [22.12.1.0](https://git.h2t.iar.kit.edu/sw/armarx/meta/axii/-/releases/22.12.1.0)

**Update procedure**:

- `axii self update`
- (with workspace activated) `axii workspace verify`

**Features**:

- CI for Axii, unit tests revamp, new end to end tests (@reister, @dreher, @kartmann, !350, !356)
- Add pytest coverage and pylint to CI (@dreher, !357, !358)
- CI subcommand to ease scripting pipelines (@kartmann, !351, !353)

**Modules**:

- `h2t/orga/software-organization`: Module has been replaced module by `h2t/software-wiki` (@kartmann, !346)
- `apt/vtk`: Add OS-specific resolving for focal (@kartmann, !344)
- `armarx_integration/ros_armarx`: Update modules for ROS integration of ArmarX (@ujrwq_arlt, !348)
- `tools/cmake/3.21`: Export CMAKE_ROOT (@jacob, !360)
- **New** `deps/openscenegraph` and `deps/ifcpp`: Modules for OpenSceneGraph and IFCPP (@kartmann, !336)
- `deps/azure-kinect/sensor-sdk`: Fix dependency issues (@utetg_groeger, !363)


## Releases 22.11


### Release [22.11.2.0](https://git.h2t.iar.kit.edu/sw/armarx/meta/axii/-/releases/22.11.2.0)

**Update procedure**:

- `axii self update`
- *Please note:* There is a new subcommand to verify your workspace's integrity: `axii workspace verify`. Give it a try and follow the instructions (if necessary).

**Features**:

- Documentation restructuring and updates (@dreher, !331, !332, !343)
- Module deprecation: Modules can now be marked as deprecated with additional information for users to migrate (@dreher, !340)
- New subcommand `axii workspace verify`: Verify workspaces considering all possible sanity checks including deprecated modules (@dreher, !341)
- Allow declaring module authors in module definition (@dreher, !342)

**Modules**:

- **New** `dbs/playground`: Module database for highly volatile and experimental modules (@pohl, @dreher, !335)
- `h2t/human_aware_navigation/teb_extension`: Fix wrong dependency (@utetg_groeger, !334)
- `deps/dlr_3d_object_tracking/icg`: Fix module dependency on default compiler (@reister, !337)
- `tools/include_what_you_use/18.0`, `tools/include_what_you_use/19.0`: Add include what you use (IWYU) (@pohl, !338)

**Fixes**:

- Prompt text might get messed up by Rich (@dreher, !339)


### Release [22.11.1.0](https://git.h2t.iar.kit.edu/sw/armarx/meta/axii/-/releases/22.11.1.0)

**Update procedure**:

- `axii self update`

**Features**:

- Allow common specifying flags for `axii workspace clean` (@uhron_lewandrowski, !321)
- Experimental Ubuntu 22.04 (Jammy) support (@ujrwq_arlt, @pohl, !195)
- Allow configuring Axii to use a specific (and dynamic) job number for building the workspace (@dreher, !328; @peller !176)

**Modules**:

- `armarx/core/arviz_godot`: ArViz Godot depends on OpenCV (@kartmann, !318)
- `armarx/skills/vision`: Add ArmarX Vision module (@pohl, !315)
- **New:** `h2t/orga/wiki/all`, `h2t/orga/wiki/staff_only`, `h2t/orga/software_organization`, `h2t/orga/wiki`, `h2t/orga`: Make docu/orga/wiki repos available (@kartmann, !320)
- `deps/bullet3`: Add missing SSH clone URL (@reister, !323)
- **New:** `armarx_integration/object_segmentation/unseen_object_clustering` and `deps/unseen_object_clustering`: (@pohl, !325)

**Fixes**:

- Properly handle errors resulting from typos in autocompletion (@jacob, !327)
- Restore original job number for parallel updates (@kartmann, !329)

## Releases 22.10

### Release [22.10.2.1](https://git.h2t.iar.kit.edu/sw/armarx/meta/axii/-/releases/22.10.2.1)

This is a patch release to:

- Update all remaining modules with their corresponding new URLs after the GitLab migration
- Temporarily limit the worker count when running the update step until rate limits on GitLab instance are adjusted

### Release [22.10.2.0](https://git.h2t.iar.kit.edu/sw/armarx/meta/axii/-/releases/22.10.2.0)

**Update procedure**:

- `axii self update`

**Features**:

- Revised documentation: Move detailed documentation to separate pages, add visualization of upgrade procedure (!308, @dreher @kartmann)
- Add maintenance command `axii self maintenance print-release-message` to aid during the release process (!307, @kartmann)

**Modules**:

- Update remote URLs of moved projects `armarx_integration/MujocoX` and `deps/epfl-dynamical-system/ds-adaptor` (!310, @kartmann)
- GitLab Migration: Update remote URLs of some migrated projects (!312, @dreher @kartmann)

### Release [22.10.1.0](https://git.h2t.iar.kit.edu/sw/armarx/meta/axii/-/releases/22.10.1.0)

**Update procedure**:

- `axii self update`

**Features**:

- Open a module's homepage, issue tracker, or merge requests using `axii module open [homepage|issues|merge-requests] [module_name]` (!304, @Meixner)
- Print a module's README either from the online Git repository (default branch) or from the current workspace is one is selected and the module is part of it using `axii module readme [module_name]` (!305, @dreher)

**Modules**:

- `h2t/research_projects/jubot/simulation`: Add missing dependencies (!299, @RainerKartmann)
- `deps/azure-kinect/sensor-sdk`: Also export `k4arecord` (!300, @tdaab)
- New `deps/hrvo`: Module for HRVO to simulate human movement (!301, @fabian.reister)
- New `deps/rvo2`: Module for RVO2 to simulate human movement (!301, @fabian.reister)
- Changes to ARMAR-7 modules (!297, @fabian.reister)
- New `h2t/research_projects/eurobin/wp2_skills`: New module for euROBIN WP2 skills (!303, @RainerKartmann)

## Releases 22.09

### Release [22.09.2.0](https://git.h2t.iar.kit.edu/sw/armarx/meta/axii/-/releases/22.09.2.0)

**Update procedure**:

- `axii self update`
- Recommended: Check out `axii w git reconfigure`, see details below in **Features**

**Features**:

- New subcommand `axii w git reconfigure`: Scan the whole workspace and ensure that the Git configuration matches the configuration of Axii's module database (!296)
  - This utility and verification tool will be important once we migrate to our own GitLab instance
  - Extended usage:
  - `axii w git reconfigure --self`: Also check if Axii is configured properly
  - `axii w git reconfigure --default-checkout`: Also ensure that the correct branches are checked out. This functionality is only implemented rudimentarily at the moment. It *can* find configuration issues, but they need to be solved manually as of now
  - `axii w git reconfigure --yes`: Do not ask, just apply changes (we don't suggest to do this unless you know it will be fine)

**Modules**:

- `armarx_integration/robots/armar6/internal_pcs/*`: Update internal PC configurations for ARMAR-6 after setting up new `armar-demo` account (!291)

### Release [22.09.1.0](https://git.h2t.iar.kit.edu/sw/armarx/meta/axii/-/releases/22.09.1.0)

**Update procedure**:

- `axii self update`
- If you are using the modules `deps/sick_scan_base`, please see notes below in **Modules** section.

**Features**:

- Unify steps (system, update, prepare, build, install, conclude), allow for only execute step on one module (!280)
- Properly update Git submodules when updating repo (!294)

**Modules**:

- `deps/azure-kinect/sensor-sdk`: Fix Azure Kinect SDK dependency on OpenCV (!288)
- New `armarx/skills/observational_learning`: Module for observational learning skills (!289)
- New `h2t/research_projects/jubot/simulation`: Module for the JuBot simulation environment (!209)
- `deps/sick_scan_base`: Switch to fork (!290) **[Action required]**
  - We had to fork the repository for various reasons (see MR for more details)
  - If you are using this module (actively or transitively), it is advised to delete the module from your workspace, and re-download and upgrade it again using `axii w ug`
- Godot editor and headless export: (!274) 
  - `deps/godot/editor`: Renamed to `tools/godot/editor`, switch to v3.5
  - New module: `deps/godot/headless`: Allows exporting Godot project without X display
- `armarx/ArmarXCore`: Create dedicated venv for ArmarX command line tool `armarx` (!292)

**Fixes**:

- Fix path/module matching when using `--path` `--this` flags (!287)

## Releases 22.08

### Release [22.08.4.0](https://git.h2t.iar.kit.edu/sw/armarx/meta/axii/-/releases/22.08.4.0)

**Notes**:

- From this release on, the versioning changed
- Main releases now are `YY.MM.r.0`, where `r` is the release number
- Patch/hotfix releases now are `YY.MM.r.p`, where `p` is the patch number for the release `r`.

**Update procedure**:

- `axii self update`
- Again, make sure that you are on the stable release channel: `axii self change-release stable`

**Features**:

- Allow overriding module definitions in workspace global config (!268)

**Modules**:

- `deps/azure-kinect/body-tracking`: Export environment variables to denote location of body tracking model files (!271)
- `deps/rc_genicam_api`: Export required environment variables used in runtime (!270)
- `deps/manif`: Fix path to project's CMake config file (!272)
- `armarx_integration/object_tracking/dlr_trackers`: Add missing dependencies (!267)
- `h2t/research_projects/robdekon/robdekon`: Update dependencies (!273)
- `h2t/research_projects/jubot/activity_recognition`: New module for Jubot Action Reccognition (!275)
- `armarx_integration/robots/armarde/skills`: Enable Azure Kinect body tracking SDK for ARMAR-DE (!276)
- `h2t/code_style`: Update code style standards, get rid of old files (!281)
- `h2t/human_aware_navigation/teb_extension`: Setting teb_extension_PATH (!282)
- `deps/{ccd,doctest,fcl,range-v3}`: Explicitly setting checkout ref, bump range-v3 version from 0.11 to 0.12 (!283)
- `h2t/research_projects/robdekon`: ROBDEKON package uses now the new robot_placement module instead of mobile_manipulation (!284)

**Fixes**:

- *None*

### Release [22.08.3](https://git.h2t.iar.kit.edu/sw/armarx/meta/axii/-/releases/22.08.3)

**Notes**:

- This is a patch release

Hotfix to correctly handle created_directory vs. extract_into in update step with archives.

### Release [22.08.2](https://git.h2t.iar.kit.edu/sw/armarx/meta/axii/-/releases/22.08.2)

**Update procedure**:

- `axii self update`
- New stable release channel was introduced, please switch to it as follows:
  - `axii self change-release stable`
  - Directly after the Axii update, you will be on the unstable channel of Axii due to the changes. The reason is that we switched the underlying branch names for development convenience reasons. You might see warnings about it directly after updating. Executing `axii self change-release stable` transitions you to Axii's stable release, which is the default you should use and which should be used on the robots.
- If you experience errors while CMaking caffe (`The dependency target "pycaffe" of target "pytest" does not exist.`):
  - Within your active workspace, remove caffe: `rm -rf "$deps__openpose__caffe_custom__PATH"`
  - Upgrade again: `axii workspace upgrade`

**Features**:

- Allow registering executables that will be auto-generated by Axii and can prepare a specific environment (!172, !253, !254)
- Minor updates to our code formatting configurations (!205, !227, !231)
- New stable release channel for more save and convenient defaults (!226)
- Executables for module authors to simplify common problems in setup bash scripts (!257)
- Allow depending on multiple packages to provide a feature in a module definition (!222)
- `archive` update step now allows to define extract target name and if archive must be set executable (.run) (!258)

**Modules**:

- New `tools/qtcreator/*`: QtCreator (5.0.3: `tools/qtcreator/5.0`, 6.0.2: `tools/qtcreator/6.0`, 7.0.2: `tools/qtcreator/7.0`, and 8.0.0: `tools/qtcreator/8.0`) (!229, !235, !255, !262)
- New `tools/pycharm/*`: PyCharm 2022.2 (CE: `tools/pycharm/community/2022.2` and P: `tools/pycharm/professional/2022.2`) (!234)
- New `tools/clang+llvm/14.0`: LLVM + Clang 14 (!225, !239, !256, !261)
- New `tools/smt_management`: SMT management module for RT PCs (!216, !239)
- New `deps/opencv-4`: OpenCV 4 (!218, !247)
- New `deps/dlr_3d_object_tracking/ICG`: DLR ICG (3D Object Tracking) (!219, !224, !246)
- New `armarx_integration/robots/armar*/*_pcs/*`Internal PC modules for ARMAR-6 (!248) and ARMAR-7 (!245)
- New `deps/azure-kinect/body-tracking` for Microsoft Azure Kinect Body Tracking SDK (requestable as feature `azure-kinect-body-tracking` from VisionX) (!263)
- Renamed `tools/git/2.35.1` to `tools/git/2.35` (!259)
- Renamed `apt/vtk6` to `apt/vtk`, installing vtk6 on Ubuntu 18.04 and vtk7 on Ubuntu 20.04 (!236, #154)
- Removed `deps/mathlib`: Use `deps/epfl-dynamical-system/ds-adaptor` instead (!244)
- `tools/cmake/3.21`: Declare executables (!252, !260 )
- `deps/cartographer`: Fix issue with Cartographer in CMake (!238, !240)
- `deps/rc_genicam_api`: Fix RC_GENICAM CMake config dir (!250)
- `deps/manif`: Fix manif CMake config dir (!251)
- `armarx/VisionX`, feature `roboception`: Roboception Genicam is now a feature of VisionX (!241)
- `armarx/skills/control`, feature `mplib`: Add feature to build MPLib-dependent controllers (!242)
- `armarx/skills/control`, feature `mathlib`: Add feature to build EPFL mathlib-dependent controllers (!249)
- `h2t/PriorKnowledgeData.json`: Declare all components as a feature of prior knowledge data (!203)
- `deps/opencv-3/main` and `deps/openpose/caffe_custom`: Explicitly set OpenCV for caffe, fixing errors on Ubuntu 20.04 (!237, #131, #155)

**Fixes**:

- An `axii w upgrade` will honour step exclusion steps again (`--no-*`) (!232, #139)
- Fix `MODULE_*` environment variables for global module (!233, #152)
- Use environment variables instead of trying to deduce script path (!230)
- Removed deprecated commands (!228)

### Release [22.08.1](https://git.h2t.iar.kit.edu/sw/armarx/meta/axii/-/releases/22.08.1)

**Update procedure**:

- `axii self update`
- Because of severe issues with PCL (!206, !208, !210, #135) we rolled back to use the apt version of PCL. Therefore, you have to trigger a full rebuild:
  - `axii workspace clean`
  - `axii workspace upgrade`

**Features**:

- Deprecated CLI commands are now dysfunctional, you should disable them via `axii config --global disable_deprecated_commands true` (!214)

**Modules**:

- Protobuf as dedicated module (dependency of Caffe/OpenPose/Cartographer) (!193)
- Mobile manipulation as ArmarX skill (!200)
- Human-aware navigation modules, make human-aware-navigation a feature of navigation (!201)
- Fix project name for mobile manipulation (!202)
- Hotfix for severe issues with PCL (!206, !208, !210, #135)

**Fixes**:

- Fix undeclared libraries in several new modules which lead to severe run-time issues (!199)
- Introduce `_AXII_DISABLE_PROMPTS` environment variable to disable prompts (!204)
- Fix runtime exceptions in `axii workspace remove` (module name not found, auto-completion) (!192)
- Code cleanup (!194)
- Fix entry point in `pyproject.toml` (!207)
- Documentation updates (!197, !198, !207)

## Releases 22.07

### Release [22.07.1](https://git.h2t.iar.kit.edu/sw/armarx/meta/axii/-/releases/22.07.1)

**Update procedure**:

In this release, Axii's internal installation was rewritten, which means that once you self update Axii you should at least resource your bashrc/zshrc or even better just close all terminals after self-updating:

- `axii self update`
- Close all terminals and re-open them
- It is recommended to re-generate your workspace environment file for each workspace: `axii w env`

Because we now build several dependencies from source, you also need to clean your entire workspace and re-build:

- `axii w clean`

Also note the [update instructions from release 22.06.1](https://git.h2t.iar.kit.edu/sw/armarx/meta/axii/-/releases/22.06.1) if you encounter any problems.

**Features**:

- CLI API overhaul (!170)
  - The subcommands of Axii were getting ambiguous due to missing scopes and therefore needed a redesign
  - The old subcommands are now deprecated, but still available and usable, they will output a warning though
  - Deprecation plan:
    - 15.7.: Deprecation, old commands still work but suggest the new commands instead
    - 22.7.: Deprecation, old commands will cease to work and suggest the new commands instead
    - 29.7.: Complete removal of old commands
  - Deprecated commands can immediately be disabled using `axii config --global disable_deprecated_commands true`
- Support variations of a module config depending on different operating systems (or versions thereof) (!178)
- Introduce script `_axii_fast_config` as a fast way to read Axii's config files (!169)
- Documentation updates and minor refactorings (!169)
- Add `ignore_patterns` option to `update` / `git` step: A list of ignore patterns which are added to the repository-local file `.git/info/exclude` during the update step (if required). (!173)
- Add flags to `install` similar to `prepare` or `build` (original contribution: !177, reimplemented in !180)

**Modules**:
- PCL source module now ignores `build/` using `ignore_patterns` (!173)
- Replace several h2t-apt-packages with Axii modules to build from source (!175)
  - This requires you to make a clean rebuild: `axii w clean; axii w upgrade`
- Added new modules: OpenPose 1.5.1 + custom Caffe (!171, !182, !185), manif (!179)
- Add OpenPose as required feature for ARMAR-6 Skills, ARMAR-DE Skills, ARMAR-7 Skills (!186)
- Add armarx::manipulation as dependency of ARMAR-6 Skills (!189)
- Add modules for PARSE by Sebastian Weigelt (!190)

**Fixes**:

- Fix issues which Axii's auto-env-refresh, where even Python venv changes were overwritten (!187)
- Correct message saying "Requested to build ..." when running `axii prepare -t` (76c753c2)

## Releases 22.06

### Release [22.06.2](https://git.h2t.iar.kit.edu/sw/armarx/meta/axii/-/releases/22.06.2)

**Note**:

- This is a patch release

Hotfix for issues for the function instructing on how to deal with improper Axii installations.

### Release [22.06.1](https://git.h2t.iar.kit.edu/sw/armarx/meta/axii/-/releases/22.06.1)

Please carefully read the part about "Shell integration and installation" before updating Axii:

**Features**:

  - Shell integration and installation (!158).

     - Axii now has to be installed by sourcing a specific bash file. Full integration in the terminal by re-sourcing the Axii workspace file after each command. To install Axii properly, execute the following steps:

         - Self-update Axii: `axii self update`.

         - Remove all remains of Axii from your `~/.bashrc` file (or `~/.zshrc` if you're using zsh). This includes sources of `.../armarx-workspace.rc`.

         - Navigate into Axii's installation directory, execute `./bootstrap` (or `./bootstrap --zsh` if you're using zsh), and follow the displayed steps.

     - Axii can now activate any workspace using `axii activate <workspace name>`. Use `axii list-workspaces` to list all known ones. You can change the workspace names in the file `~/.config/axii/known_workspaces.json`.

     - The shell integration (also auto-completion) will now work by default, the command to activate auto-completion is now obsolete.

  - Database modules: Modules can now be database modules and claim the authority of a sub-namespace. Axii can lazy-load these database modules (!155).

**Fixes**:

  - Git and/or SSH blocking update step while cloning due to user prompts. Related to this, we now no longer need to build Git from source (!165).

  - Structural reworks, improved error handling, improved user outputs, and error handling suggestions (!163).

  - Fixed a bug where features in a workspace were not activated correctly (!156).

  - Performance improvements (!160)
