"""Supplies strategies for the `conclude` step."""

import dataclasses as dc
from typing import List, Optional

from armarx_setup.core.module import common
from armarx_setup.core.module.context import Hook
from armarx_setup.core.util import dataclass


@dc.dataclass
class Conclude(Hook):
    run: Optional[common.Run] = None

    def __post_init__(self):
        kwargs = { "ctx": self.ctx }
        sub_step_enabled_kwargs = { "list_factory": common.SubStepAdapter.list_factory, **kwargs }

        self.run = dataclass.sanitize_type(self.run, common.Run, **sub_step_enabled_kwargs)

    def _get_sub_hooks(self) -> List[Hook]:
        return [self.run]
