#!/bin/bash

# Set by Axii.
python3_armarx_dir="$armarx__python3_armarx__PATH"
mycroft_core_dir="$mycroft_core_DIR"

python_package_dir_rel="python/mycroftarmarx"
plugins_symlink_target_rel="mycroftarmarx/plugins"

python_package_dir="$MODULE_PATH/$python_package_dir_rel"
plugins_symlink_target="$python_package_dir/$plugins_symlink_target_rel"

mycroft_core_venv_dir="$mycroft_core_dir/.venv"
mycroft_core_plugin_symlink_name="$mycroft_core_DIR/mycroft/plugins"


if [[ ! -d "$mycroft_core_dir" ]]; then
  echo "Project Mycroft Core not found at '$mycroft_core_dir'."
  exit 1
fi

if [[ ! -d "$python3_armarx_dir" ]]; then
  echo "Project Python3 ArmarX not found at '$python3_armarx_dir'."
  exit 2
fi

if [[ ! -d "$mycroft_core_venv_dir" ]]; then
  echo "Virtual environment of Mycroft Core not found at '$mycroft_core_venv_dir'."
  echo "Please upgrade Mycroft core first: 'axii workspace upgrade -m deps/mycroft-core'"
  exit 3
fi

source "$mycroft_core_venv_dir/bin/activate"

echo "Installing '$python3_armarx_dir' into virtual environment of Mycroft Core at '$mycroft_core_venv_dir' ..."
pip install --upgrade -e "$python3_armarx_dir"

echo ""

echo "Installing '$python_package_dir' into virtual environment of Mycroft Core at '$mycroft_core_venv_dir' ..."
pip install --upgrade -e "$python_package_dir"

echo ""

echo "Creating symlink '$mycroft_core_plugin_symlink_name' to '$plugins_symlink_target' ..."
ln -s -f -n "$plugins_symlink_target" "$mycroft_core_plugin_symlink_name"
