#!/bin/bash

# Set by Axii.
mycroft_core_dir="$mycroft_core_DIR"

python_package_dir_rel="python/armar6_mycroft_skills"
plugins_symlink_target_rel="mycroftarmarx/plugins"

python_package_dir="$MODULE_PATH/$python_package_dir_rel"

mycroft_core_venv_dir="$mycroft_core_dir/.venv"


if [[ ! -d "$mycroft_core_dir" ]]; then
  echo "Project Mycroft Core not found at '$mycroft_core_dir'."
  exit 1
fi

if [[ ! -d "$mycroft_core_venv_dir" ]]; then
  echo "Virtual environment of Mycroft Core not found at '$mycroft_core_venv_dir'."
  echo "Please upgrade Mycroft core first: 'axii workspace upgrade -m deps/mycroft-core'"
  exit 3
fi

source "$mycroft_core_venv_dir/bin/activate"

echo "Installing '$python_package_dir' into virtual environment of Mycroft Core at '$mycroft_core_venv_dir' ..."
pip install --upgrade -e "$python_package_dir"

