#!/bin/bash

file_content='SUBSYSTEMS=="usb", ATTRS{idVendor}=="2341", GROUP="plugdev", MODE="0666"'
destination_path="/etc/udev/rules.d/99-k4a.rules"

if [[ ! -f "$destination_path" ]]; then
  echo "Installing udev rules needed for uploading programs to Arduino boards. Running:"
  echo "echo \"$file_content\" | sudo tee -a \"$destination_path\""
  echo "Note: To apply these changes, you need to reboot the system afterwards."
  read -p "Do you want to proceed? y/N " -r
  echo  # new line

  if [[ $REPLY =~ ^[Yy]$ ]]; then
    echo "$file_content" | sudo tee -a "$destination_path"
  fi
fi
