import os

from armarx_setup.core.module.update import Download

from tests.unit.core.module import DummyContext


def test_absolute_creation():
    data = {
        "url": "https://example.com/",
        "file": "/dev/null/does_not-exist.tar.gz",
        "ctx": DummyContext()
    }
    download = Download(**data)

    assert download.url == "https://example.com/"
    assert download.file == "/dev/null/does_not-exist.tar.gz"


def test_env_var():
    os.environ["THIS_IS_A_TEST"] = "test_value"

    data = {
        "url": "https://example.com/$THIS_IS_A_TEST",
        "file": "/test/$THIS_IS_A_TEST.tar.gz",
        "ctx": DummyContext()
    }
    download = Download(**data)

    assert download.url == "https://example.com/test_value"
    assert download.file == "/test/test_value.tar.gz"
