from armarx_setup.core.util.json.comments import is_comment, remove_comments


def test_remove_comments_from_list():
    out = remove_comments([
        "hello",
        "# sir",
        "madam",
    ])
    expected = [
        "hello",
        "madam",
    ]
    assert out == expected, f"out: \n{out}\n expected: \n{expected}"


def test_remove_comments_from_dict():
    out = remove_comments({
        "hello": "dear",
        "# sir": "foo",
        "madam": "bar",
    })
    expected = {
        "hello": "dear",
        "madam": "bar",
    }
    assert out == expected, f"out: \n{out}\n expected: \n{expected}"


def test_remove_comments_nested():
    out = remove_comments({
        "greeting": [
            "hello",
            "# sir",
            "madam",
        ],
        "# comment": "next is the body",
        "body": {
            "main": [
                "# This",
                "# text",
                "# was scratched"
            ],
            "footer": {
                "ps": [
                    "Thanks",
                    "# a bunch"
                ],
                "# ps ps": "Will anyone ever read this?"
            }
        },
    })
    expected = {
        "greeting": [
            "hello",
            "madam",
        ],
        "body": {
            "main": [],
            "footer": {
                "ps": [
                    "Thanks",
                ],
            }
        }
    }
    assert out == expected, f"out: \n{out}\n expected: \n{expected}"
